
/*
XMail OSAX -- Copyright (C) 2004 Jean-Baptiste LE STANG jb.lestang@libertysurf.fr

	
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include <Carbon/Carbon.h>
#include "Terminology.h"
#include "mail.h"
#include "smtp.h"
#include "dlist.h"


OSStatus	XMailMakeErrorReply( AppleEvent *theReply, const OSErr theErrorCode,char * theMessage );
OSStatus	XMailGetDescString( const AEDesc *theDesc, char ** theString );

OSStatus	XMailGetTextParamAsString( const AppleEvent *theEvent, const AEKeyword theKeyword, char ** theField );
OSStatus	XMailGetUnicodeParamAsString( const AppleEvent *theEvent, const AEKeyword theKeyword, const TextEncoding toEncoding, char ** theField );
OSStatus	XMailGetListItemAsString( const AEDescList *theList, const DescType theType, const SInt32 theIndex, char ** theField );
OSStatus	XMailGetParamListItemAsString( const AppleEvent *theEvent, const AEKeyword theKeyword, const DescType theType, const SInt32 theIndex, char ** theField );
OSStatus	XMailDoGetSSLCertificates(const AppleEvent * theEvent,char ** ca_path, char ** ca_dir);

int			XMailGetToRecipientsCount(const AppleEvent * theEvent);

OSStatus	XMailGenerateRcptsList(const AppleEvent * theEvent, mail_t * mail);
OSStatus	XMailGenerateKeyWordRcptsList(const AppleEvent * theEvent,AEKeyword key, mail_t * mail);


OSStatus	XMailDoReplyTo(const AppleEvent * theEvent, mail_t * mail);
OSStatus	XMailDoErrorsTo(const AppleEvent * theEvent, mail_t * mail);	
OSStatus	XMailDoLogin(const AppleEvent * theEvent, mail_t * mail);
OSStatus	XMailDoPassword(const AppleEvent * theEvent, mail_t * mail);
OSStatus	XMailDoBody(const AppleEvent * theEvent, mail_t * mail);
OSStatus	XMailDoSubject(const AppleEvent * theEvent, mail_t * mail);
OSStatus	XMailDoServer(const AppleEvent * theEvent, mail_t * mail);
OSStatus	XMailDoFrom(const AppleEvent * theEvent, mail_t * mail);
OSStatus	XMailDoGetSSL(const AppleEvent * theEvent, mail_t * mail);
OSStatus	XMailDoGetPort(const AppleEvent * theEvent, mail_t * mail);
OSStatus	XMailDoGetTimeout(const AppleEvent * theEvent, mail_t * mail);
OSStatus	XMailDoRecipients(const AppleEvent * e,const AEKeyword key,mail_t * mail,recipient rcptKind );
OSStatus	XMailDoAttachments(const AppleEvent *theEvent,mail_t * mail) ;
OSStatus	XMailDoPriority(const AppleEvent *theEvent,mail_t * mail);
OSStatus	XMailDoExtraHeaders(const AppleEvent *theEvent,mail_t * mail);
OSStatus	XMailDoGetSASL(const AppleEvent * theEvent,mail_t * mail);

OSStatus sendMail( const AppleEvent *theEvent, AppleEvent *theReply, long theRefCon );
OSStatus sendMailRaw( const AppleEvent *theEvent, AppleEvent *theReply, long theRefCon );
OSStatus unicodeFind(const AppleEvent *theEvent, AppleEvent *theReply, long theRefCon);
OSStatus encodeMimeStyle(const AppleEvent *theEvent, AppleEvent *theReply, long theRefCon);
OSStatus encodeQP(const AppleEvent *theEvent, AppleEvent *theReply, long theRefCon);
OSStatus encodeEmail(const AppleEvent *theEvent, AppleEvent *theReply, long theRefCon);
OSStatus matchEmail( const AppleEvent *theEvent, AppleEvent *theReply, long theRefCon );
OSStatus matchName( const AppleEvent *theEvent, AppleEvent *theReply, long theRefCon );
OSStatus rfc822Date(const AppleEvent *theEvent, AppleEvent *theReply, long theRefCon);
OSStatus mimeBound(const AppleEvent *theEvent, AppleEvent *theReply, long theRefCon);
OSStatus mimeOfFile(const AppleEvent *theEvent, AppleEvent *theReply, long theRefCon);

OSStatus XMailRegister(const AppleEvent *theEvent, AppleEvent *theReply, long theRefCon);
